// #autoload 
// #name = ThirdRep
// #category = ilys' Scripts
// #config = ThirdRepGUI

$ThirdRep::pickup = "1";
$ThirdRep::use = "1";

if(!isFile("prefs/thirdrepprefs.cs")) export("$ThirdRep::*", "prefs/thirdrepprefs.cs", false);
exec("prefs/thirdrepprefs.cs");

package ThirdRep 
{ 
	function PlayGui::onWake(%this)
	{
		parent::onWake(%this);
		if(!isObject(thirdrepret))
		{
			%width = 256;
			%height = 256;
			%x = (getWord($pref::Video::resolution, 0) * 0.5) - (0.5 * %width);
			%y = (getWord($pref::Video::resolution, 1) * 0.5) - (0.5 * %height);
			new HudBitmapCtrl(thirdrepret) { 
				profile = "GuiConsoleProfile"; 
				horizSizing = "bottom"; 
				vertSizing = "right"; 
				position = %x SPC %y; 
				extent = %width SPC %height; 
				minExtent = "8 8"; 
				visible = "0"; 
				helpTag = "0"; 
				hideCursor = "0"; 
				bypassHideCursor = "0"; 
				helpTag = "0"; 
				bitmap = "gui/ret_chaingun"; 
				autoCenter = "1"; 
				autoResize = "1"; 
				flipVertical = "0"; 
				flipHorizontal = "0"; 
			}; 
			PlayGui.add(thirdrepret);
		}
	}
	function clientCmdsetRepairPackIconOn()
	{
		if($firstperson && $ThirdRep::use)
		{
			if($goFirstPerson !$= "") cancel($goFirstPerson);
			$firstperson = 0;
			hudFirstPersonToggled();
		}
		parent::clientCmdsetRepairPackIconOn();
	}
	function clientCmdsetRepairPackIconOff()
	{
		if(!$firstperson && $ThirdRep::use)
		{
			$firstperson = 1;
			hudFirstPersonToggled();
		}
		parent::clientCmdsetRepairPackIconOff();
	}
	function clientCmdSetBackpackHudItem(%num, %addItem) 
	{ 
		Parent::clientCmdSetBackpackHudItem(%num, %addItem);
		if(%addItem)
		{
			$currpack = $BackPackHudData[%num, ItemDataName];
			if($currpack $= "RepairPack") 
			{
				if($firstperson && $ThirdRep::pickup)
				{
					$firstperson = 0;
					hudFirstPersonToggled();
					$goFirstPerson = schedule(1000,0,goFirstPerson);
				}
			}
		}
	}
	function hudFirstPersonToggled()
	{
		parent::hudFirstPersonToggled();
		if($currpack $= "RepairPack" && $HudMode !$= "Observer" && $HudMode !$= "Object" && $HudMode !$= "Pilot")  thirdrepret.setVisible(!$firstperson);
		else thirdrepret.setVisible(0);
	}
	function goFirstPerson()
	{
		$firstperson = 1;
		hudFirstPersonToggled();
	}
	function quit()
	{
		parent::quit();
		export("$ThirdRep::*", "prefs/thirdrepprefs.cs", false);
	}
	function ThirdRepGUI::OnWake()
	{
		// No console spam please
	}
};
activatepackage(ThirdRep);

new GuiControl(ThirdRepGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "150 90";
	minExtent = "150 90";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "150 90";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		new GuiTextCtrl() {
			profile = "DebriefHeadlineTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 5";
			extent = "150 32";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "ThirdRep Options";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "22 35";
			extent = "125 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$ThirdRep::pickup";
			helpTag = "0";
			text = "Thirdperson Pickup";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "22 55";
			extent = "125 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$ThirdRep::use";
			helpTag = "0";
			text = "Thirtperson on use";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};